#include "or.h"
#include "dlg_util.h"
#include "dlg_resize.h"

WINDOWPLACEMENT wndPlacement;
RECT rParent,rRef,rCtrl,newSize;
RECT childDlg;
POINT delta;
int deltax=0,deltay=0;

resize_info_t *get_resize_info(RECT newSize,int list_item);
void resizeInit(HWND hDlg,resize_info_t *resize_tmp);

resize_info_t resize_main[]={
	{201,0,0,0,0,{0,83,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{200,201,201,0,0,{5,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{1001,0,0,0,201,{13,0,0,-7},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{1002,0,0,0,201,{13,0,0,-19},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{1003,0,0,0,201,{13,0,0,-49},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{9,0,0,0,1001,{0,0,0,-70},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{10,0,0,0,1001,{0,0,0,-70},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{1,0,9,9,9,{571,23,-18,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{6,0,1,1,1,{510,23,-6,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{8,0,9,6,6,{0,23,0,0},RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{3,0,8,8,8,{591,23,-6,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{5,0,3,3,3,{605,23,-6,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{4,0,5,5,5,{605,23,-6,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{2,0,4,4,4,{4,23,-5,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_proxy[]={
	{-1,430,360,0,0,{-1,-1,-1,-1},0},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_banned_addresses[]={
	{-1,380,160,0,0,{-1,-1,-1,-1},0},
	{13104,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{13406,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{13105,0,0,0,0,{17,49,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{13401,0,0,0,0,{8,0,0,44},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{13402,0,0,0,0,{8,0,0,23},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_advanced_proxy[]={
	{-1,415,160,0,0,{-1,-1,-1,-1},0},
	{13102,0,0,0,0,{8,87,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{13402,0,0,0,0,{0,0,0,79},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{13103,0,0,0,0,{0,0,0,83},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{13403,0,0,0,0,{0,0,0,55},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{13404,0,0,0,0,{0,0,0,28},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_proxy_http[]={
	{-1,440,445,0,0,{-1,-1,-1,-1},0},
	{16300,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16301,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16302,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16303,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16304,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16400,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16403,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16404,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16405,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16406,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{16050,16300,0,0,0,{3187,9,0,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{16100,16050,0,0,0,{9,19,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{16051,0,0,16050,0,{8,9,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{16407,0,0,16051,0,{21,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X},
	{16408,0,0,16051,0,{17,0,-22,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X},
	{16409,0,0,16051,0,{21,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X},
	{16410,0,0,16051,0,{17,0,-22,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_authorities[]={
	{-1,425,345,0,0,{-1,-1,-1,-1},0},
	{18012,0,0,0,0,{0,0,0,259},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18020,0,0,0,0,{0,0,0,259},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18401,0,0,0,0,{0,0,0,237},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18402,0,0,0,0,{0,0,0,214},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18001,0,0,0,0,{0,0,0,191},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18403,0,0,0,0,{0,0,0,161},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18101,0,0,0,0,{0,0,0,165},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18404,0,0,0,0,{0,0,0,139},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18405,0,0,0,0,{0,0,0,116},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18010,0,0,0,0,{0,0,0,95},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18102,0,0,0,0,{0,0,0,97},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18011,0,0,0,0,{0,0,0,95},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18406,0,0,0,0,{0,0,0,72},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18407,0,0,0,0,{0,0,0,49},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18103,0,0,0,0,{0,0,0,53},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18408,0,0,0,0,{0,0,0,23},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18104,0,0,0,0,{0,0,0,27},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18014,0,0,0,0,{0,0,0,23},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{18000,0,18401,0,0,{10,28,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT},
	{18100,0,18401,0,0,{16,38,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_router_restrictions[]={
	{-1,435,215,0,0,{-1,-1,-1,-1},0},
	{15050,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15004,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15500,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_router_bans[]={
	{-1,380,95,0,0,{-1,-1,-1,-1},0},
	{15051,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15100,0,0,0,0,{8,9,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_router_favorites[]={
	{-1,395,160,0,0,{-1,-1,-1,-1},0},
	{15408,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15409,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15503,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15052,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{15101,0,0,0,0,{8,9,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_circuit_build[]={
	{-1,405,315,0,0,{-1,-1,-1,-1},0},
	{14051,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{14107,0,14051,14051,0,{17,8,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{14100,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14400,14100,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14412,14100,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14101,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14401,14101,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14108,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14413,14108,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14109,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14414,14109,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14102,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14402,14102,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14103,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14403,14103,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14104,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14404,14104,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14301,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14411,14301,0,0,0,{87,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14105,0,0,14301,0,{0,0,84,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X},
	{14110,0,0,14051,0,{19,0,164864,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X},
	{14410,14110,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{14001,0,0,14051,0,{19,0,110,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{14300,14001,0,0,0,{3,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_tracked_hosts[]={
	{-1,420,305,0,0,{-1,-1,-1,-1},0},
	{14050,0,0,0,0,{3937,1881,0,0},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_RELATIVE_TO_HEIGHT_HEIGHT},
	{14010,0,0,0,0,{22,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{14106,0,14050,0,0,{21,10,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{14408,0,0,0,14050,{12,9,0,-6},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{14011,0,0,0,14408,{26,0,0,-21},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{14108,0,0,0,14408,{21,45,0,-79},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y},
	{14409,14108,0,0,0,{60757,0,0,35},RESIZE_FLAG_RELATIVE_TO_POS_LEFT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{14109,0,0,14409,0,{22,0,-3,41},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_identity[]={
	{-1,428,660,0,0,{-1,-1,-1,-1},0},
	{12010,0,0,0,0,{8,162,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{12400,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12011,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12409,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12020,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12401,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12012,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12402,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12013,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12403,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12014,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12408,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12019,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12404,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12015,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12405,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12016,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12406,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12017,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12407,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12018,0,0,0,0,{13,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12410,0,0,0,0,{13,0,0,156},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12021,0,0,0,0,{13,0,0,135},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12411,0,0,0,0,{0,0,0,83},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12100,0,0,0,0,{309,0,0,83},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12300,0,0,12100,12100,{0,0,-4,21},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12500,0,0,12100,12100,{0,0,-125,21},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12501,0,0,12100,12100,{0,0,-125,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{12412,0,0,12100,12100,{13,0,100,-21},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_connections[]={
	{-1,395,395,0,0,{-1,-1,-1,-1},0},
	{10300,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10100,10300,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10301,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10101,10301,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10302,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10102,10302,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10303,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10103,10303,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10304,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10104,10304,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10306,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10113,10306,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10307,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10114,10307,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10305,0,0,0,0,{0,0,124,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{10105,10305,0,0,0,{6,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH},
	{10106,0,0,0,0,{97,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10111,0,0,0,0,{16,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10112,0,0,0,0,{16,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10107,0,0,0,0,{16,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10108,0,0,0,0,{16,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10109,0,0,0,0,{16,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{10110,0,0,0,0,{16,4,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_bridges[]={
	{-1,435,360,0,0,{-1,-1,-1,-1},0},
	{24010,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{24400,0,0,0,0,{21,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{24401,0,0,0,0,{17,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{24002,0,0,0,0,{22,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{24409,0,0,0,0,{0,0,0,193},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24105,0,0,0,0,{8,0,0,198},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24003,0,0,0,0,{0,0,0,172},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24106,0,0,0,0,{8,0,0,177},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24004,0,0,0,0,{0,0,0,151},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24107,0,0,0,0,{8,0,0,156},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24402,0,0,0,0,{17,0,0,130},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24404,0,0,0,0,{21,0,0,109},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24405,0,0,0,0,{0,0,0,88},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24101,0,0,0,0,{80,0,0,93},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24300,0,0,24101,0,{0,0,0,93},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24406,0,0,0,0,{0,0,0,67},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24102,0,0,0,0,{8,0,0,72},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24407,0,0,0,0,{0,0,0,46},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24103,0,0,0,0,{80,0,0,51},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24301,0,0,24103,0,{0,0,0,51},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24408,0,0,0,0,{0,0,0,25},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24104,0,0,0,0,{8,0,0,30},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{24050,0,0,0,0,{17,203,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{24100,0,0,0,0,{26,208,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_bypass_blacklists[]={
	{-1,430,480,0,0,{-1,-1,-1,-1},0},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_hs[]={
	{-1,400,310,0,0,{-1,-1,-1,-1},0},
	{19100,0,0,0,0,{-45,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{19011,0,0,19100,0,{0,0,-14,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19101,0,0,19011,0,{85,0,-4,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19001,0,0,0,0,{0,0,76,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19102,0,0,0,0,{-45,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{19013,0,0,19102,0,{0,0,-14,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19103,0,0,19013,0,{85,0,-4,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19020,0,0,0,0,{0,0,76,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19400,0,0,0,0,{100,161,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{19003,0,0,0,0,{0,0,89,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19004,0,0,0,0,{0,0,89,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19005,0,0,0,0,{0,0,89,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{19014,0,0,0,0,{0,0,0,151},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19104,0,0,0,0,{13,0,0,154},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19015,0,0,0,0,{0,0,0,125},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19105,0,0,0,0,{13,0,0,128},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19016,0,0,0,0,{0,0,0,98},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19106,0,0,0,0,{13,0,0,102},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19017,0,0,0,0,{0,0,0,72},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19107,0,0,0,0,{13,0,0,76},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19018,0,0,0,0,{0,0,0,46},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19108,0,0,0,0,{13,0,0,49},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19019,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{19109,0,0,0,0,{13,0,0,23},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_plugins[]={
	{-1,340,100,0,0,{-1,-1,-1,-1},0},
	{26400,0,0,0,0,{8,36,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{26001,26400,0,0,0,{697,0,0,30},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26002,26400,0,26001,0,{697,0,-4,30},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26003,26400,0,26002,0,{697,0,-5,30},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26004,26400,0,26003,0,{697,0,-4,30},RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26006,0,0,0,0,{0,0,49,30},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26007,0,0,0,0,{0,0,26,30},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{26005,26006,0,26004,0,{4,0,-5,30},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_system[]={
	{-1,425,498,0,0,{-1,-1,-1,-1},0},
	{11300,0,0,0,0,{34,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11100,0,0,0,0,{34,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11013,0,0,0,0,{0,0,27,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_X},
	{11301,0,0,11013,0,{35,0,-4,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11400,11013,0,0,0,{96,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11401,0,0,0,0,{25,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11402,0,0,0,0,{25,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11403,0,0,0,0,{25,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11404,0,0,0,0,{25,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11101,0,0,0,0,{-15,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{11012,0,0,11101,0,{0,0,-6,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11102,0,0,11012,0,{34,0,-3,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11406,0,0,0,0,{148,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11103,0,0,11012,0,{34,0,-3,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11050,0,0,0,0,{12,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11110,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11111,0,0,11110,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11203,0,0,11110,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11104,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11107,0,0,11104,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11200,0,0,11104,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11105,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11108,0,0,11105,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11201,0,0,11105,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11106,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11109,0,0,11106,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11202,0,0,11106,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11116,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11119,0,0,11116,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11120,0,0,11116,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11118,11050,0,0,0,{154,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11121,0,0,11118,0,{0,0,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11122,0,0,11118,0,{0,0,-63,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{11112,0,0,0,0,{22,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11113,0,0,0,0,{215,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{11114,0,0,11113,0,{0,0,-4,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_force_tor[]={
	{-1,330,100,0,0,{-1,-1,-1,-1},0},
	{12010,0,0,0,0,{8,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12400,0,0,0,0,{8,9,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_quick_start[]={
	{-1,365,220,0,0,{-1,-1,-1,-1},0},
	{12010,0,0,0,0,{116,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{12400,0,0,0,0,{111,9,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{12001,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{12002,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{12003,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{12004,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{12005,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{12006,0,0,0,0,{0,0,98,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_sandboxing[]={
	{-1,330,100,0,0,{-1,-1,-1,-1},0},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_server[]={
	{-1,435,310,0,0,{-1,-1,-1,-1},0},
	{17100,0,0,0,0,{-63,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{17010,0,0,17100,0,{0,0,-6,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17101,0,0,17010,0,{10,0,-3,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17102,0,0,0,0,{-63,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{17012,0,0,17102,0,{0,0,-6,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17103,0,0,17012,0,{10,0,-3,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17104,0,0,0,0,{10,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{17016,0,0,0,0,{10,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH},
	{17050,0,0,0,0,{-3,28,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{17108,0,0,0,0,{-9,33,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{17051,0,0,17050,0,{7,28,-3,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17109,0,0,17050,0,{13,33,-9,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{17017,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17407,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17408,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17409,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17410,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17411,0,0,0,0,{0,0,0,20},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{17001,0,0,0,0,{0,0,106,23},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_network_information[]={
	{-1,250,225,0,0,{-1,-1,-1,-1},0},
	{25010,0,0,0,0,{0,0,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH},
	{25500,0,0,0,0,{1,119,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{25011,0,0,25500,0,{8,0,-13,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{25100,0,25500,25500,0,{8,31,-4,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X},
	{25001,25100,0,25100,25100,{-1,0,-4,-4},RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25002,0,0,25001,25100,{11,0,-4,-4},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25050,0,0,0,0,{0,0,0,114},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25012,0,0,0,0,{0,0,0,95},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25013,0,0,0,0,{0,0,0,95},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25014,0,0,0,0,{0,0,0,77},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25015,0,0,0,0,{0,0,0,77},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25052,0,0,0,0,{0,0,0,62},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25016,0,0,0,0,{0,0,0,42},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25017,0,0,0,0,{0,0,0,42},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25018,0,0,0,0,{0,0,0,25},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25019,0,0,0,0,{0,0,0,25},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{25051,0,0,0,0,{13,0,0,109},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_debug[]={
	{-1,405,75,0,0,{0,0,0,0},0},
	{100,0,0,0,0,{-2,27,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{400,0,0,0,0,{0,0,0,22},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{401,0,0,0,0,{0,0,0,22},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{300,0,0,0,0,{131,0,0,22},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{11,0,0,300,0,{0,0,-4,22},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{10,0,0,11,0,{0,0,-4,22},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_about[]={
	{16010,0,0,0,0,{2,7,0,0},RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT},
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};

resize_info_t resize_plugin[]={
	{0,0,0,0,0,{-1,-1,-1,-1},0}
};


void scrollChildren(HWND hDlg,int amountx,int amounty)
{	HWND hNext = NULL;
	RECT rChild;
	POINT p1;
	while(1)
	{	hNext = FindWindowEx(hDlg,hNext,NULL,NULL);
		if(!hNext)	break;
		GetWindowRect(hNext,&rChild);
		rChild.right -= rChild.left;
		rChild.bottom -= rChild.top;
		p1.x = rChild.left;
		p1.y = rChild.top;
		ScreenToClient(hDlg,&p1);
		if(IsWindowVisible(hNext))
		{	ShowWindow(hNext,SW_HIDE);
			MoveWindow(hNext,p1.x-amountx,p1.y-amounty,rChild.right,rChild.bottom,1);
			ShowWindow(hNext,SW_SHOW);
		}
		else	MoveWindow(hNext,p1.x-amountx,p1.y-amounty,rChild.right,rChild.bottom,0);
	}
	deltax += amountx;
	deltay += amounty;
	if(amountx)	SetScrollPos(hDlg,SB_HORZ,deltax,1);
	if(amounty)	SetScrollPos(hDlg,SB_VERT,deltay,1);
	RedrawWindow(hDlg,NULL,NULL,RDW_FRAME|RDW_INVALIDATE|RDW_UPDATENOW|RDW_ALLCHILDREN|RDW_NOERASE);
}

void scrollBack(HWND hDlg)
{	if(deltax ||  deltay)
	{	HWND hNext = NULL;
		RECT rChild;
		POINT p1;
		while(1)
		{	hNext = FindWindowEx(hDlg,hNext,NULL,NULL);
			if(!hNext)	break;
			GetWindowRect(hNext,&rChild);
			rChild.right -= rChild.left;
			rChild.bottom -= rChild.top;
			p1.x = rChild.left;
			p1.y = rChild.top;
			ScreenToClient(hDlg,&p1);
			MoveWindow(hNext,p1.x+deltax,p1.y+deltay,rChild.right,rChild.bottom,IsWindowVisible(hNext));
		}
		if(deltax)	SetScrollPos(hDlg,SB_HORZ,0,0);
		if(deltay)	SetScrollPos(hDlg,SB_VERT,0,0);
		deltax = 0;
		deltay = 0;
	}
}

int translateScroll(HWND hDlg,DWORD scrCode,int scrType)
{	int minpos,maxpos,scrpos;
	GetScrollRange(hDlg,scrType,&minpos,&maxpos);
	scrpos = GetScrollPos(hDlg,scrType);
	switch(LOWORD(scrCode))
	{	case SB_TOP:
			return scrpos - minpos;
		case SB_BOTTOM:
			return maxpos - scrpos;
		case SB_ENDSCROLL:
			return 0;
		case SB_LINEUP:
			if(scrpos > minpos)	return -1;
			return 0;
		case SB_LINEDOWN:
			if(scrpos < maxpos)	return 1;
			return 0;
		case SB_PAGEUP:
			if(scrpos > minpos-8)	return -8;
			return scrpos - minpos;
		case SB_PAGEDOWN:
			if(scrpos < maxpos-8)	return 8;
			return maxpos-scrpos;
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			scrType = HIWORD(scrCode);
			if(scrType > scrpos)
			{	if(scrType<maxpos)
					return scrType - scrpos;
				return maxpos - scrpos;
			}
			if(scrType>minpos)
				return scrType - scrpos;
			return scrpos - minpos;
	}
	return 0;
}

void resizeDialogControls(HWND hDlg,resize_info_t *resizeInfo,int minwidth,int minheight)
{	GetWindowRect(hDlg,&rParent);
	GetClientRect(hDlg,&rRef);
	rParent.right = rParent.left + rRef.right-rRef.left;
	rParent.bottom = rParent.top + rRef.bottom-rRef.top;
	if(rParent.bottom - rParent.top < minheight)	rParent.bottom = minheight + rParent.top;
	if(rParent.right - rParent.left < minwidth)	rParent.right = minwidth + rParent.left;
	delta.x=0;delta.y=0;ClientToScreen(hDlg,&delta);
	int i = 0;
	if(resizeInfo[0].ctrlId==-1)	i++;
	for(;resizeInfo[i].ctrlId;i++)
	{	GetWindowRect(GetDlgItem(hDlg,resizeInfo[i].ctrlId),&rCtrl);

		if(resizeInfo[i].flags&RESIZE_MASK_POSX_NEED_REF)
		{	if(resizeInfo[i].refPosXControl)
				GetWindowRect(GetDlgItem(hDlg,resizeInfo[i].refPosXControl),&rRef);
			else
			{	rRef.left = rParent.left;rRef.right = rParent.right;
				rRef.top = rParent.top;rRef.bottom = rParent.bottom;
			}
			if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X)
				newSize.left=rRef.left-resizeInfo[i].reference.right;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X)
				newSize.left=rRef.right-resizeInfo[i].reference.right;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_X)
				newSize.left=((rRef.right+rRef.left)>>1)-resizeInfo[i].reference.right;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_LEFT_POS_X)
				newSize.left=(((rRef.left-rParent.left)*resizeInfo[i].reference.right)>>12)+rParent.left;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X)
				newSize.left=(((rParent.right-rRef.right)*resizeInfo[i].reference.right)>>12)+rParent.left;
		}
		else if(resizeInfo[i].flags&RESIZE_FLAG_FIXED_POS_X)
		{	newSize.left=resizeInfo[i].reference.right;
		}
		else newSize.left=rCtrl.left;

		if(resizeInfo[i].flags&RESIZE_MASK_POSY_NEED_REF)
		{	if(resizeInfo[i].refPosYControl)
				GetWindowRect(GetDlgItem(hDlg,resizeInfo[i].refPosYControl),&rRef);
			else
			{	rRef.left = rParent.left;rRef.right = rParent.right;
				rRef.top = rParent.top;rRef.bottom = rParent.bottom;
			}
			if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y)
				newSize.top=rRef.top-resizeInfo[i].reference.bottom;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y)
				newSize.top=rRef.bottom-resizeInfo[i].reference.bottom;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_Y)
				newSize.top=((rRef.bottom+rRef.top)>>1)-resizeInfo[i].reference.bottom;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_TOP_POS_Y)
				newSize.top=(((rRef.top-rParent.top)*resizeInfo[i].reference.bottom)>>12)+rParent.top;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_BOTTOM_POS_Y)
				newSize.top=(((rParent.bottom-rRef.bottom)*resizeInfo[i].reference.bottom)>>12)+rParent.top;
		}
		else if(resizeInfo[i].flags&RESIZE_FLAG_FIXED_POS_Y)
		{	newSize.top=resizeInfo[i].reference.bottom;
		}
		else newSize.top=rCtrl.top;

		if(resizeInfo[i].flags&RESIZE_MASK_WIDTH_NEED_REF)
		{	if(resizeInfo[i].refWidthControl)
				GetWindowRect(GetDlgItem(hDlg,resizeInfo[i].refWidthControl),&rRef);
			else
			{	rRef.left = rParent.left;rRef.right = rParent.right;
				rRef.top = rParent.top;rRef.bottom = rParent.bottom;
			}
			if((resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH) && (resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH))
				newSize.right=rRef.right-rRef.left;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH)
				newSize.right=rRef.left-resizeInfo[i].reference.left-newSize.left;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH)
				newSize.right=rRef.right-resizeInfo[i].reference.left-newSize.left;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH)
				newSize.right=((rRef.right+rRef.left)>>1)+resizeInfo[i].reference.left-newSize.left;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH)
				newSize.right=((rRef.right-rRef.left)*resizeInfo[i].reference.left)>>12;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_LEFT_WIDTH)
				newSize.right=((rRef.left-rParent.left)*resizeInfo[i].reference.left)>>12;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_RIGHT_WIDTH)
				newSize.right=((rParent.right-rRef.right)*resizeInfo[i].reference.left)>>12;
		}
		else if(resizeInfo[i].flags&RESIZE_FLAG_FIXED_WIDTH)
			newSize.right=resizeInfo[i].reference.left;
		else
			newSize.right=rCtrl.right-rCtrl.left;

		if(resizeInfo[i].flags&RESIZE_MASK_HEIGHT_NEED_REF)
		{	if(resizeInfo[i].refHeightControl)
				GetWindowRect(GetDlgItem(hDlg,resizeInfo[i].refHeightControl),&rRef);
			else
			{	rRef.left = rParent.left;rRef.right = rParent.right;
				rRef.top = rParent.top;rRef.bottom = rParent.bottom;
			}
			if((resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT) && (resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT))
				newSize.bottom=rRef.bottom-rRef.top;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT)
				newSize.bottom=rRef.top-resizeInfo[i].reference.top-newSize.top;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT)
				newSize.bottom=rRef.bottom-resizeInfo[i].reference.top-newSize.top;
			else if(resizeInfo[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_HEIGHT)
				newSize.bottom=((rRef.bottom+rRef.top)>>1)+resizeInfo[i].reference.top-newSize.top;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_HEIGHT_HEIGHT)
				newSize.bottom=((rRef.bottom-rRef.top)*resizeInfo[i].reference.top)>>12;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_TOP_HEIGHT)
				newSize.bottom=((rRef.top-rParent.top)*resizeInfo[i].reference.top)>>12;
			else if(resizeInfo[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_BOTTOM_HEIGHT)
				newSize.bottom=((rParent.bottom-rRef.bottom)*resizeInfo[i].reference.top)>>12;
		}
		else if(resizeInfo[i].flags&RESIZE_FLAG_FIXED_HEIGHT)
			newSize.bottom=resizeInfo[i].reference.top;
		else
			newSize.bottom=rCtrl.bottom-rCtrl.top;
		newSize.left -= delta.x;
		newSize.top -= delta.y;
		MoveWindow(GetDlgItem(hDlg,resizeInfo[i].ctrlId),newSize.left,newSize.top,newSize.right,newSize.bottom,0);
	}
}

void resizeInit(HWND hDlg,resize_info_t *resize_tmp)
{	RECT r1,r2,r3;
	int i = 0;
	GetWindowRect(hDlg,&r3);
	if(resize_tmp[0].ctrlId==-1)	i++;
	for(;resize_tmp[i].ctrlId;i++)
	{	GetWindowRect(GetDlgItem(hDlg,resize_tmp[i].ctrlId),&r2);
		if(resize_tmp[i].refWidthControl)	GetWindowRect(GetDlgItem(hDlg,resize_tmp[i].refWidthControl),&r1);
		else	GetWindowRect(hDlg,&r1);
		if(resize_tmp[i].flags&RESIZE_FLAG_FIXED_WIDTH)
		{	resize_tmp[i].reference.left=r2.right-r2.left;
		}
		else if((resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH) && (resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH))
		{	resize_tmp[i].reference.left=r1.right-r1.left;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH)
		{	resize_tmp[i].reference.left=r1.left-r2.right;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH)
		{	resize_tmp[i].reference.left=r1.right-r2.right;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH)
		{	resize_tmp[i].reference.left=r2.right-((r1.right+r1.left)/2);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH)
		{	resize_tmp[i].reference.left=((r2.right-r2.left)*4096)/(r1.right-r1.left);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_LEFT_WIDTH)
		{	resize_tmp[i].reference.left=((r2.right-r2.left)*4096)/(r1.left-r3.left);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_RIGHT_WIDTH)
		{	resize_tmp[i].reference.left=((r2.right-r2.left)*4096)/(r3.right-r1.right);
		}
		else resize_tmp[i].reference.left=0;

		if(resize_tmp[i].refHeightControl)	GetWindowRect(GetDlgItem(hDlg,resize_tmp[i].refHeightControl),&r1);
		else	GetWindowRect(hDlg,&r1);
		if(resize_tmp[i].flags&RESIZE_FLAG_FIXED_HEIGHT)
		{	resize_tmp[i].reference.top=r2.bottom-r2.top;
		}
		else if((resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT) && (resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT))
		{	resize_tmp[i].reference.top=r1.bottom-r1.top;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT)
		{	resize_tmp[i].reference.top=r1.top-r2.bottom;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT)
		{	resize_tmp[i].reference.top=r1.bottom-r2.bottom;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_HEIGHT)
		{	resize_tmp[i].reference.top=r2.bottom-((r1.bottom+r1.top)/2);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_HEIGHT_HEIGHT)
		{	resize_tmp[i].reference.top=((r2.bottom-r2.top)*4096)/(r1.bottom-r1.top);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_TOP_HEIGHT)
		{	resize_tmp[i].reference.top=((r2.bottom-r2.top)*4096)/(r1.top-r3.top);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_POS_BOTTOM_HEIGHT)
		{	resize_tmp[i].reference.top=((r2.bottom-r2.top)*4096)/(r3.bottom-r1.bottom);
		}
		else resize_tmp[i].reference.top=0;

		if(resize_tmp[i].refPosXControl)	GetWindowRect(GetDlgItem(hDlg,resize_tmp[i].refPosXControl),&r1);
		else	GetWindowRect(hDlg,&r1);
		if(resize_tmp[i].flags&RESIZE_FLAG_FIXED_POS_X)
		{	resize_tmp[i].reference.right=r2.left-r3.left;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X)
		{	resize_tmp[i].reference.right=r1.left-r2.left;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X)
		{	resize_tmp[i].reference.right=r1.right-r2.left;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_X)
		{	resize_tmp[i].reference.right=(r1.right+r1.left)/2-r2.left;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_LEFT_POS_X)
		{	resize_tmp[i].reference.right=((r2.left-r3.left)*4096)/(r1.left-r3.left);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X)
		{	resize_tmp[i].reference.right=((r2.left-r3.left)*4096)/(r3.right-r1.right + (r3.right==r1.right));
		}
		else resize_tmp[i].reference.right=0;

		if(resize_tmp[i].refPosYControl)	GetWindowRect(GetDlgItem(hDlg,resize_tmp[i].refPosYControl),&r1);
		else	GetWindowRect(hDlg,&r1);
		if(resize_tmp[i].flags&RESIZE_FLAG_FIXED_POS_Y)
		{	resize_tmp[i].reference.bottom=r2.top-r3.top;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y)
		{	resize_tmp[i].reference.bottom=r1.top-r2.top;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y)
		{	resize_tmp[i].reference.bottom=r1.bottom-r2.top;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_Y)
		{	resize_tmp[i].reference.bottom=(r1.bottom+r1.top)/2-r2.top;
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_TOP_POS_Y)
		{	resize_tmp[i].reference.bottom=((r2.top-r3.top)*4096)/(r1.top-r3.top);
		}
		else if(resize_tmp[i].flags&RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_BOTTOM_POS_Y)
		{	resize_tmp[i].reference.bottom=((r2.top-r3.top)*4096)/(r3.bottom-r1.bottom);
		}
		else resize_tmp[i].reference.bottom=0;
		log(LOG_DEBUG,LD_APP,"CtrlId: %u, reference.left: %ld, reference.top: %ld, reference.right: %ld, reference.bottom: %ld",resize_tmp[i].ctrlId,resize_tmp[i].reference.left,resize_tmp[i].reference.top,resize_tmp[i].reference.right,resize_tmp[i].reference.bottom);
	}
}

void resizeChildDialog(HWND hParent,HWND hChild,resize_info_t *resizeInfo)
{	RECT tmpRect;POINT p1;
	int sBars = 0;
	GetClientRect(hParent,&childDlg);
	GetWindowRect(GetDlgItem(hParent,201),&tmpRect);
	tmpRect.right -= tmpRect.left;
	tmpRect.bottom -= tmpRect.top;
	p1.x=tmpRect.left;p1.y=tmpRect.top;
	ScreenToClient(hParent,&p1);
	childDlg.right -= childDlg.left + p1.x + tmpRect.right + 3;
	childDlg.left = p1.x + tmpRect.right + 1;
	childDlg.top = 0;
	childDlg.bottom = p1.y + tmpRect.bottom;
	if(resizeInfo && resizeInfo[0].ctrlId==0 && resizeInfo[0].refWidthControl)	resizeInfo=get_resize_info(childDlg,resizeInfo[0].refWidthControl);
	else if(!resizeInfo[0].ctrlId)	resizeInfo = NULL;
	if(resizeInfo)
	{	int i = 0;
		if(resizeInfo[0].ctrlId==-1)	i++;
		if(resizeInfo[i].reference.left==-1)	resizeInit(hChild,resizeInfo);
	}
	if(resizeInfo && resizeInfo[0].ctrlId==-1)
	{	MoveWindow(hChild,childDlg.left,childDlg.top,childDlg.right,childDlg.bottom,1);
		GetClientRect(hChild,&childDlg);
		if(childDlg.bottom < resizeInfo[0].refHeightControl)
		{	ShowScrollBar(hChild,SB_VERT,1);
			GetClientRect(hChild,&childDlg);
			sBars |= 1;
		}
		else	ShowScrollBar(hChild,SB_VERT,0);
		if(childDlg.right < resizeInfo[0].refWidthControl)
		{	ShowScrollBar(hChild,SB_HORZ,1);
			GetClientRect(hChild,&childDlg);
			sBars |= 2;
			if(childDlg.bottom < resizeInfo[0].refHeightControl)
			{	ShowScrollBar(hChild,SB_VERT,1);
				sBars |= 1;
			}
		}
		else	ShowScrollBar(hChild,SB_HORZ,0);
		if(sBars)
		{	GetClientRect(hChild,&childDlg);
			if(sBars & 1)	SetScrollRange(hChild,SB_VERT,0,resizeInfo[0].refHeightControl-childDlg.bottom,1);
			if(sBars & 2)	SetScrollRange(hChild,SB_HORZ,0,resizeInfo[0].refWidthControl-childDlg.right,1);
		}
		else if(deltax || deltay)	scrollBack(hChild);
		resizeDialogControls(hChild,resizeInfo,(childDlg.right < resizeInfo[0].refWidthControl)?resizeInfo[0].refWidthControl:childDlg.right,(childDlg.bottom < resizeInfo[0].refHeightControl)?resizeInfo[0].refHeightControl:childDlg.bottom);
	}
	else
	{	MoveWindow(hChild,childDlg.left,childDlg.top,childDlg.right,childDlg.bottom,1);
		if(resizeInfo)	resizeDialogControls(hChild,resizeInfo,childDlg.right,childDlg.bottom);
	}
}
