/* Copyright 2001-2004 Roger Dingledine.
 * Copyright (c) 2004-2006, Roger Dingledine, Nick Mathewson.
 * Copyright (c) 2007-2008, The Tor Project, Inc. */
/* See LICENSE for licensing information */

/** String describing which Tor subversion repository version the source was
 * built from.  This string is generated by a bit of shell kludging int
 * src/or/Makefile.am, and is usually right.
 */
#include "or.h"
#include "language.h"
#include <windows.h>

char *_version;

/**
 * \file tor_main.c
 * \brief Stub module containing a main() function. Allows unit
 * test binary to link against main.c.
 **/

int tor_main(int argc, char *argv[]);

/** We keep main() in a separate file so that our unit tests can use
 * functions from main.c)
 */
int main(void)	// we no longer accept argc and *argv[] here because we make our own, converted from UNICODE to UTF-8
{
	int argc;
	char **argv;
	char *cmdtmp;
	int i=0,j=1,k;
	tor_alloc_init();
	cmdtmp = get_utf(GetCommandLineW());
	for(i=0;cmdtmp[i];i++)
	{	if(cmdtmp[i]=='\"')
		{	while(cmdtmp[i+1]!='\"' && cmdtmp[i+1]!=0)
				i++;
			if(cmdtmp[i+1]=='\"')
				i++;
		}
		else if(cmdtmp[i]==32 || cmdtmp[i]==9 || cmdtmp[i]==13 || cmdtmp[i]==10)
		{	j++;
			while(cmdtmp[i+1]==32 || cmdtmp[i+1]==9 || cmdtmp[i+1]==13 || cmdtmp[i+1]==10)
				i++;
		}
	}
	argv=tor_malloc(j*sizeof(char *));
	argc = 0;
	for(i=0;cmdtmp[i];)
	{	if(cmdtmp[i]==32 || cmdtmp[i]==9 || cmdtmp[i]==13 || cmdtmp[i]==10)
		{	while(cmdtmp[i+1]==32 || cmdtmp[i+1]==9 || cmdtmp[i+1]==13 || cmdtmp[i+1]==10)
				i++;
		}
		argv[argc++]=&cmdtmp[i];
		if(argc>j)
			tor_assert(0);
		while(cmdtmp[i]!=32 && cmdtmp[i]!=9 && cmdtmp[i]!=13 && cmdtmp[i]!=10 && cmdtmp[i]!=0)
		{	if(cmdtmp[i]==34)
			{	i++;
				while(cmdtmp[i]!=34 && cmdtmp[i]!=0)
					i++;
				if(cmdtmp[i]==34)
					i++;
			}
			else
				i++;
		}
		if(cmdtmp[i])
			cmdtmp[i++]=0;
	}
	for(i=0;i<argc;i++)
	{	for(j=0,k=0;argv[i][j];j++)
		{	if(argv[i][j]!=34)
				argv[i][k++]=argv[i][j];
		}
		argv[i][k]=0;
	}

	int result = tor_main(argc,argv);

	tor_free(cmdtmp);
	tor_free(argv);

	TerminateProcess(GetCurrentProcess(),result);
	ExitProcess(result);
	return result;
}

